import 'package:flutter/material.dart';
import 'package:flutter_bloc/flutter_bloc.dart';
import '../../../../res/images/images.dart';
import '../../playvideo/page/play_video.dart';
import '../bloc/lesson_bloc.dart';
import '../model/lesson_model.dart';

class LessionWidget extends StatelessWidget {
  String lessonID;

   LessionWidget( this.lessonID, {Key? key}) : super(key: key);

  LessonModel? lessonModel;

  String pl = 'Playlist video';

  @override
  Widget build(BuildContext context) {
    BlocProvider.of<LessonBloc>(context).add(
        RequestLesson(context: context, lessonID: lessonID));
    return
      BlocConsumer<LessonBloc, LessonState>(
          listener: (context, state) async {},
          builder: (context, state) {
            return
              BlocBuilder<LessonBloc, LessonState>(
                  builder: (context, state) {
                    if(state is LessonInitial){
                      return const Text('LessonInitial');
                    }
                    if(state is LessonFailed){
                      return const Text('LessonFailed');
                    }
                    if(state is LessonLoading){
                      return const CircularProgressIndicator();
                    }
                    if(state is LessonSuccess){
                      return
                        state.lessonModel.data!.isNotEmpty?ListView.builder(
                            shrinkWrap: true,
                            itemCount: state.lessonModel.data!.length,
                            itemBuilder: (context, index){
                              return
                                InkWell(
                                  onTap: (){
                                    state.lessonModel.data![index].partType == 'YOUTUBE'?
                                    Navigator.push(
                                      context,
                                      MaterialPageRoute(builder: (context) => PlayVideoPage(link: state.lessonModel.data![index].playlist![0].link!)),
                                    ):const Text('---------');
                                  },
                                  child: Row(
                                    mainAxisAlignment: MainAxisAlignment.spaceBetween,
                                    children: [
                                      Padding(
                                          padding: const EdgeInsets.fromLTRB(30, 3, 0, 3),
                                          child: Image.asset(Images.o,height: 10,width: 10,)),
                                      Padding(
                                        padding: const EdgeInsets.fromLTRB(0, 0, 0, 0),
                                        child:
                                        Text(state.lessonModel.data![index].title!=null?state.lessonModel.data![index].title!:''),
                                      ),
                                      Padding(
                                        padding: const EdgeInsets.fromLTRB(20, 3, 20, 3),
                                        child: state.lessonModel.data![index].partType=='YOUTUBE'?Padding(
                                          padding: const EdgeInsets.fromLTRB(20, 3, 20, 3),
                                          child: Image.asset(Images.see,height: 20,width: 20,),
                                        ):Padding(
                                          padding: const EdgeInsets.fromLTRB(20, 3, 20, 3),
                                          child: Image.asset(Images.uneye,height: 20,width: 20,),
                                        ),
                                      ),
                                    ],),
                                );
                            }
                        ):const Text('');

                    }
                    return const Text('NewFailed');
                  }
              );
          }
      );
  }
}


